"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.requestMethod = exports.Jumbo = void 0;
var axios_1 = __importDefault(require("axios"));
var product_1 = require("./product/product");
var store_1 = require("./store/store");
var tokenHandler_1 = require("./auth/tokenHandler");
var https_1 = __importDefault(require("https"));
var order_1 = require("./order/order");
var promotion_1 = require("./promotion/promotion");
var recipe_1 = require("./recipe/recipe");
var user_1 = require("./user/user");
var category_1 = require("./category/category");
var list_1 = require("./list/list");
var endpoint = 'https://mobileapi.jumbo.com/v12/';
var Jumbo = /** @class */ (function () {
    function Jumbo(username, password, verbose) {
        this.username = username;
        this.password = password;
        this.verbose = verbose;
        // Create https agent for TLSv1.2 or less (API doesn't respond to TLSv1.3+)
        this.client = axios_1.default.create({
            httpsAgent: new https_1.default.Agent({
                maxVersion: 'TLSv1.2',
            }),
        });
        // Set separate classes
        this.jumboCategory = new category_1.Category(this, false);
        this.jumboList = new list_1.List(this, false);
        this.jumboOrder = new order_1.Order(this, true);
        this.jumboProduct = new product_1.Product(this, false);
        this.jumboPromotion = new promotion_1.Promotion(this, false);
        this.jumboRecipe = new recipe_1.Recipe(this, false);
        this.jumboStore = new store_1.Store(this, false);
        this.jumboUser = new user_1.User(this, true);
        // Login using given username and password
        if (username && password) {
            this.login(username, password);
        }
    }
    Jumbo.prototype.category = function () {
        return this.jumboCategory;
    };
    Jumbo.prototype.list = function () {
        return this.jumboList;
    };
    Jumbo.prototype.order = function () {
        return this.jumboOrder;
    };
    Jumbo.prototype.product = function () {
        return this.jumboProduct;
    };
    Jumbo.prototype.promotion = function () {
        return this.jumboPromotion;
    };
    Jumbo.prototype.recipe = function () {
        return this.jumboRecipe;
    };
    Jumbo.prototype.store = function () {
        return this.jumboStore;
    };
    Jumbo.prototype.user = function () {
        return this.jumboUser;
    };
    /**
     * Function that creates a new TokenHandler for given username and password
     * @param username Jumbo account username (e-mail)
     * @param password Jumbo account password
     */
    Jumbo.prototype.login = function (username, password) {
        this.tokenHandler = new tokenHandler_1.TokenHandler(this, username, password);
    };
    /**
     * PUT request
     * @param path Endpoint URL (without start)
     * @param body Body of PUT (if any)
     * @param extraHeaders Any extra headers
     * @param query Any query options
     * @param authRequired Whether a token is required for the function
     * @param fullResponse Returns response + headers instead of only data
     */
    Jumbo.prototype.put = function (path, body, extraHeaders, query, authRequired, fullResponse) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.request(path, requestMethod.PUT, body, extraHeaders, query, authRequired, fullResponse)];
            });
        });
    };
    /**
     * POST request
     * @param path Endpoint URL (without start)
     * @param body Body of POST
     * @param extraHeaders Any extra headers
     * @param query Any query options
     * @param authRequired Whether a token is required for the function
     * @param fullResponse Returns response + headers instead of only data
     */
    Jumbo.prototype.post = function (path, body, extraHeaders, query, authRequired, fullResponse) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.request(path, requestMethod.POST, body, extraHeaders, query, authRequired, fullResponse)];
            });
        });
    };
    /**
     * GET request
     * @param path Endpoint URL (without start)
     * @param extraHeaders Any extra headers
     * @param query Any query options
     * @param authRequired Whether a token is required for the function
     * @param fullResponse Returns response + headers instead of only data
     */
    Jumbo.prototype.get = function (path, extraHeaders, query, authRequired, fullResponse) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.request(path, requestMethod.GET, undefined, extraHeaders, query, authRequired, fullResponse)];
            });
        });
    };
    /**
     * Generic request method
     * @param path Endpoint URL (without start)
     * @param method Request method (GET, POST, PUT, DELETE)
     * @param body Body in case of POST and PUT
     * @param extraHeaders Any extra headers (Content-Type and Accept) are already included
     * @param query Query in case of GET
     * @param authRequired Whether a token is required for the function
     * @param fullResponse Returns response + headers instead of only data
     */
    Jumbo.prototype.request = function (path, method, body, extraHeaders, query, authRequired, fullResponse) {
        return __awaiter(this, void 0, void 0, function () {
            var requestHeaders, url, response, text;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!authRequired) return [3 /*break*/, 3];
                        if (!!this.tokenHandler) return [3 /*break*/, 1];
                        throw new Error("You must be logged in to access this path: " + (endpoint + path));
                    case 1: 
                    // If the tokenHandler doesn't have a token yet, make sure it gets one
                    return [4 /*yield*/, this.tokenHandler.Ready];
                    case 2:
                        // If the tokenHandler doesn't have a token yet, make sure it gets one
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        requestHeaders = this.createHeader(authRequired, extraHeaders);
                        url = this.createURL(path, query);
                        // Log if verbose
                        if (this.verbose) {
                            console.log(url);
                            console.log(method);
                            console.log(requestHeaders);
                            void (body && console.log(body));
                        }
                        return [4 /*yield*/, this.client.request({
                                method: method,
                                url: url,
                                headers: requestHeaders,
                                data: body,
                            })];
                    case 4:
                        response = _a.sent();
                        // Throw error if response not ok
                        if (!response.statusText) {
                            text = response.data;
                            throw new Error(response.statusText + ": " + text);
                        }
                        if (fullResponse) {
                            return [2 /*return*/, response];
                        }
                        // Return response in JSON format
                        return [2 /*return*/, response.data];
                }
            });
        });
    };
    /**
     * Helper function to create headers for request
     * @param extraHeaders Any extra header options
     */
    Jumbo.prototype.createHeader = function (authRequired, extraHeaders) {
        // Create header
        var headers = __assign({ 'Content-Type': 'application/json', 'User-Agent': 'jumbo-wrapper' }, extraHeaders);
        if (authRequired && this.tokenHandler) {
            headers['x-jumbo-token'] = this.tokenHandler.getToken();
        }
        else if (authRequired && !this.tokenHandler) {
            throw new Error('You must be logged in to use this function');
        }
        // Return the headers
        return headers;
    };
    /**
     * Helper function to create request URL
     * @param path Path to endpoint (without ENDPOINT in .env)
     * @param query Any query options
     */
    Jumbo.prototype.createURL = function (path, query) {
        var url;
        // Add query if given
        if (query) {
            var params = new URLSearchParams(query);
            url = endpoint + path + '?' + params;
        }
        else {
            url = endpoint + path;
        }
        // Return URL
        return url;
    };
    return Jumbo;
}());
exports.Jumbo = Jumbo;
/**
 * Simple enum for different request methods
 */
var requestMethod;
(function (requestMethod) {
    requestMethod["GET"] = "GET";
    requestMethod["POST"] = "POST";
    requestMethod["PUT"] = "PUT";
})(requestMethod = exports.requestMethod || (exports.requestMethod = {}));
