"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrderStatus = exports.Order = void 0;
var jumboObject_1 = require("../base/jumboObject");
var date_fns_1 = require("date-fns");
var Order = /** @class */ (function (_super) {
    __extends(Order, _super);
    function Order() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Gets order from ID
     * @param orderId Order ID
     */
    Order.prototype.getMyOrderById = function (orderId, headers, query) {
        return __awaiter(this, void 0, void 0, function () {
            var order;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.jumbo.get("users/me/orders/" + orderId, headers, query, this.authRequired)];
                    case 1:
                        order = _a.sent();
                        // Convert times to dates
                        return [2 /*return*/, this.convertOrderResponseToOrderModel(order.order.data)];
                }
            });
        });
    };
    /**
     * Returns all the users' orders
     * @param offset Offset (default 0)
     * @param count Amount of orders (default 10)
     */
    Order.prototype.getMyOrders = function (offset, count, headers, query) {
        return __awaiter(this, void 0, void 0, function () {
            var orders;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.jumbo.get("users/me/orders", headers, __assign({ offset: (offset ? offset : 0).toString(), count: (count ? count : 10).toString() }, query), this.authRequired)];
                    case 1:
                        orders = _a.sent();
                        // Convert responses to models
                        return [2 /*return*/, orders.orders.data.map(function (orderResponse) {
                                return _this.convertOrderResponseToOrderModel(orderResponse);
                            })];
                }
            });
        });
    };
    /**
     * Shortcut function to return latest (first) order
     */
    Order.prototype.getMyLatestOrder = function (headers, query) {
        return __awaiter(this, void 0, void 0, function () {
            var orders;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getMyOrders(0, 1, headers, query)];
                    case 1:
                        orders = _a.sent();
                        return [2 /*return*/, orders[0]];
                }
            });
        });
    };
    /**
     * Returns all of the user's orders with a certain status
     * @param status Status of the order (Processing, Open, Completed)
     */
    Order.prototype.getMyOrdersByStatus = function (status, headers, query) {
        return __awaiter(this, void 0, void 0, function () {
            var orders;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getMyOrders(undefined, undefined, headers, query)];
                    case 1:
                        orders = _a.sent();
                        return [2 /*return*/, orders.filter(function (order) {
                                return order.order.data.status === status;
                            })];
                }
            });
        });
    };
    /**
     * Shortcut function to retrieve the latest order that matches the status
     * @param status Status of the order
     */
    Order.prototype.getMyLatestOrderByStatus = function (status, headers, query) {
        return __awaiter(this, void 0, void 0, function () {
            var orders;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getMyOrdersByStatus(status, headers, query)];
                    case 1:
                        orders = _a.sent();
                        return [2 /*return*/, orders[0]];
                }
            });
        });
    };
    /**
     * Gets the user's relevant orders (which includes shipping time)
     */
    Order.prototype.getMyRelevantOrders = function (headers, query) {
        return __awaiter(this, void 0, void 0, function () {
            var orders;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getMyOrders(undefined, undefined, headers, __assign({ relevant: 'true' }, query))];
                    case 1:
                        orders = _a.sent();
                        return [2 /*return*/, orders];
                }
            });
        });
    };
    /**
     * Converts response to actual data by first converting unix timestamps to dates
     * @param order OrderResponse to convert
     */
    Order.prototype.convertOrderResponseToOrderModel = function (order) {
        // Simply convert the delivery object and cut-off date
        var orderModel = {
            order: {
                data: __assign(__assign({}, order), { delivery: this.convertDeliveryTimesToDates(order.delivery), orderCutOffDate: this.convertUnixDateToDate(order.orderCutOffDate), shipping: undefined }),
            },
        };
        // Add shipping if required
        if (order.shipping) {
            orderModel.order.data.shipping = this.convertShippingTimesToDates(order.shipping);
        }
        return orderModel;
    };
    /**
     * Converts shipping unix timestamps of order to actual dates
     * @param shipping order.data.shipping
     */
    Order.prototype.convertShippingTimesToDates = function (shipping) {
        var shippingDate = {
            plannedETAStart: this.convertUnixDateToDate(shipping.plannedETAStart),
            plannedETAEnd: this.convertUnixDateToDate(shipping.plannedETAEnd),
            unknownLiveETA: shipping.unknownLiveETA,
        };
        if (shipping.liveETA) {
            shippingDate.liveETA = this.convertUnixDateToDate(shipping.liveETA);
        }
        return shippingDate;
    };
    /**
     * Converts delivery unix timestamps of order to actual dates
     * @param delivery order.data.delivery
     */
    Order.prototype.convertDeliveryTimesToDates = function (delivery) {
        // First convert these 3 separately
        var date = this.convertUnixDateToDate(delivery.date);
        var startDate = this.convertUnixDateToDate(delivery.startDateTime);
        var endDate = this.convertUnixDateToDate(delivery.endDateTime);
        // Add them to return object
        var deliveryDate = {
            address: delivery.address,
            date: date,
            endDateTime: endDate,
            location: delivery.location,
            price: delivery.price,
            startDateTime: startDate,
            time: delivery.time,
        };
        // Only convert and add collection date if it's in the original delivery data
        if (delivery.collectionDateTime) {
            var collectionDate = this.convertUnixDateToDate(delivery.collectionDateTime);
            deliveryDate.collectionDateTime = collectionDate;
        }
        return deliveryDate;
    };
    /**
     * Converts given unix timestamp to a Date
     */
    Order.prototype.convertUnixDateToDate = function (unixDate) {
        return date_fns_1.fromUnixTime(this.formatUnixTimestamp(unixDate));
    };
    /**
     * Strips the last 3 digits off the timestamp to properly convert
     */
    Order.prototype.formatUnixTimestamp = function (unixDate) {
        return (unixDate - (unixDate % 1000)) / 1000;
    };
    return Order;
}(jumboObject_1.JumboObject));
exports.Order = Order;
var OrderStatus;
(function (OrderStatus) {
    OrderStatus["Processing"] = "PROCESSING";
    OrderStatus["Open"] = "OPEN";
    OrderStatus["ReadyToDeliver"] = "READY_TO_DELIVER";
    OrderStatus["Completed"] = "PICKED_UP";
})(OrderStatus = exports.OrderStatus || (exports.OrderStatus = {}));
