import { Headers, Query } from '../jumbo';
import { JumboObject } from '../base/jumboObject';
import { StoreModel } from './storeModel';
export declare class Store extends JumboObject {
    /**
     * Gets store from store ID
     * @param storeId Store ID
     */
    getStoreFromId(storeId: number, headers?: Headers, query?: Query): Promise<StoreModel>;
    /**
     * Find stores based on given longitude, latitude and distance (optional)
     * @param long Longitude
     * @param lat Latitude
     * @param distance Maximum search radius (default none)
     * @param count Number of stores to retrieve (default 20)
     * @param offset Offset in search (default 0)
     */
    getStoresFromLongLat(long: number, lat: number, distance?: number, count?: number, offset?: number, headers?: Headers, query?: Query): Promise<StoreModel[]>;
    /**
     * Shortcut function to get the nearest store given longitude and latitude
     * @param long Longitude
     * @param lat Latitude
     */
    getNearestStoreFromLongLat(long: number, lat: number, headers?: Headers, query?: Query): Promise<StoreModel>;
}
